/*!
 * Snowplow ecommerce tracking v4.5.0 (http://bit.ly/sp-js)
 * Copyright 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
 * Licensed under BSD-3-Clause
 */

(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.snowplowEcommerceAccelerator = {}));
})(this, (function (exports) { 'use strict';

  /******************************************************************************
  Copyright (c) Microsoft Corporation.

  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.

  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */

  var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
  };

  function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
  }

  function __spreadArray(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
  }

  typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
  };

  /*!
   * Core functionality for Snowplow JavaScript trackers v4.5.0 (http://bit.ly/sp-js)
   * Copyright 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * Licensed under BSD-3-Clause
   */

  /*
   * Copyright (c) 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * All rights reserved.
   *
   * Redistribution and use in source and binary forms, with or without
   * modification, are permitted provided that the following conditions are met:
   *
   * 1. Redistributions of source code must retain the above copyright notice, this
   *    list of conditions and the following disclaimer.
   *
   * 2. Redistributions in binary form must reproduce the above copyright notice,
   *    this list of conditions and the following disclaimer in the documentation
   *    and/or other materials provided with the distribution.
   *
   * 3. Neither the name of the copyright holder nor the names of its
   *    contributors may be used to endorse or promote products derived from
   *    this software without specific prior written permission.
   *
   * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
   * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   */
  function payloadBuilder() {
      var dict = {}, allJson = [], jsonForProcessing = [], contextEntitiesForProcessing = [];
      var processor;
      var add = function (key, value) {
          if (value != null && value !== '') {
              // null also checks undefined
              dict[key] = value;
          }
      };
      var addDict = function (dict) {
          for (var key in dict) {
              if (Object.prototype.hasOwnProperty.call(dict, key)) {
                  add(key, dict[key]);
              }
          }
      };
      var addJson = function (keyIfEncoded, keyIfNotEncoded, json) {
          if (json && isNonEmptyJson(json)) {
              var jsonWithKeys = { keyIfEncoded: keyIfEncoded, keyIfNotEncoded: keyIfNotEncoded, json: json };
              jsonForProcessing.push(jsonWithKeys);
              allJson.push(jsonWithKeys);
          }
      };
      var addContextEntity = function (entity) {
          contextEntitiesForProcessing.push(entity);
      };
      return {
          add: add,
          addDict: addDict,
          addJson: addJson,
          addContextEntity: addContextEntity,
          getPayload: function () { return dict; },
          getJson: function () { return allJson; },
          withJsonProcessor: function (jsonProcessor) {
              processor = jsonProcessor;
          },
          build: function () {
              processor === null || processor === void 0 ? void 0 : processor(this, jsonForProcessing, contextEntitiesForProcessing);
              return dict;
          },
      };
  }
  /**
   * Is property a non-empty JSON?
   * @param property - Checks if object is non-empty json
   */
  function isNonEmptyJson(property) {
      if (!isJson(property)) {
          return false;
      }
      for (var key in property) {
          if (Object.prototype.hasOwnProperty.call(property, key)) {
              return true;
          }
      }
      return false;
  }
  /**
   * Is property a JSON?
   * @param property - Checks if object is json
   */
  function isJson(property) {
      return (typeof property !== 'undefined' &&
          property !== null &&
          (property.constructor === {}.constructor || property.constructor === [].constructor));
  }

  /*
   * Copyright (c) 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * All rights reserved.
   *
   * Redistribution and use in source and binary forms, with or without
   * modification, are permitted provided that the following conditions are met:
   *
   * 1. Redistributions of source code must retain the above copyright notice, this
   *    list of conditions and the following disclaimer.
   *
   * 2. Redistributions in binary form must reproduce the above copyright notice,
   *    this list of conditions and the following disclaimer in the documentation
   *    and/or other materials provided with the distribution.
   *
   * 3. Neither the name of the copyright holder nor the names of its
   *    contributors may be used to endorse or promote products derived from
   *    this software without specific prior written permission.
   *
   * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
   * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
   * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   */
  var label = 'Snowplow: ';
  var LOG_LEVEL;
  (function (LOG_LEVEL) {
      LOG_LEVEL[LOG_LEVEL["none"] = 0] = "none";
      LOG_LEVEL[LOG_LEVEL["error"] = 1] = "error";
      LOG_LEVEL[LOG_LEVEL["warn"] = 2] = "warn";
      LOG_LEVEL[LOG_LEVEL["debug"] = 3] = "debug";
      LOG_LEVEL[LOG_LEVEL["info"] = 4] = "info";
  })(LOG_LEVEL || (LOG_LEVEL = {}));
  var LOG = logger();
  function logger(logLevel) {
      if (logLevel === void 0) { logLevel = LOG_LEVEL.warn; }
      function setLogLevel(level) {
          if (LOG_LEVEL[level]) {
              logLevel = level;
          }
          else {
              logLevel = LOG_LEVEL.warn;
          }
      }
      /**
       * Log errors, with or without error object
       */
      function error(message, error) {
          var extraParams = [];
          for (var _i = 2; _i < arguments.length; _i++) {
              extraParams[_i - 2] = arguments[_i];
          }
          if (logLevel >= LOG_LEVEL.error && typeof console !== 'undefined') {
              var logMsg = label + message + '\n';
              if (error) {
                  console.error.apply(console, __spreadArray([logMsg + '\n', error], extraParams, false));
              }
              else {
                  console.error.apply(console, __spreadArray([logMsg], extraParams, false));
              }
          }
      }
      /**
       * Log warnings, with or without error object
       */
      function warn(message, error) {
          var extraParams = [];
          for (var _i = 2; _i < arguments.length; _i++) {
              extraParams[_i - 2] = arguments[_i];
          }
          if (logLevel >= LOG_LEVEL.warn && typeof console !== 'undefined') {
              var logMsg = label + message;
              if (error) {
                  console.warn.apply(console, __spreadArray([logMsg + '\n', error], extraParams, false));
              }
              else {
                  console.warn.apply(console, __spreadArray([logMsg], extraParams, false));
              }
          }
      }
      /**
       * Log debug messages
       */
      function debug(message) {
          var extraParams = [];
          for (var _i = 1; _i < arguments.length; _i++) {
              extraParams[_i - 1] = arguments[_i];
          }
          if (logLevel >= LOG_LEVEL.debug && typeof console !== 'undefined') {
              console.debug.apply(console, __spreadArray([label + message], extraParams, false));
          }
      }
      /**
       * Log info messages
       */
      function info(message) {
          var extraParams = [];
          for (var _i = 1; _i < arguments.length; _i++) {
              extraParams[_i - 1] = arguments[_i];
          }
          if (logLevel >= LOG_LEVEL.info && typeof console !== 'undefined') {
              console.info.apply(console, __spreadArray([label + message], extraParams, false));
          }
      }
      return { setLogLevel: setLogLevel, warn: warn, error: error, debug: debug, info: info };
  }
  /**
   * Build a self-describing event
   * A custom event type, allowing for an event to be tracked using your own custom schema
   * and a data object which conforms to the supplied schema
   *
   * @param event - Contains the properties and schema location for the event
   * @returns PayloadBuilder to be sent to {@link @snowplow/tracker-core#TrackerCore.track}
   */
  function buildSelfDescribingEvent(event) {
      var _a = event.event, schema = _a.schema, data = _a.data, pb = payloadBuilder();
      var ueJson = {
          schema: 'iglu:com.snowplowanalytics.snowplow/unstruct_event/jsonschema/1-0-0',
          data: { schema: schema, data: data },
      };
      pb.add('e', 'ue');
      pb.addJson('ue_px', 'ue_pr', ueJson);
      return pb;
  }

  /*!
   * Core functionality for Snowplow Browser trackers v4.5.0 (http://bit.ly/sp-js)
   * Copyright 2022 Snowplow Analytics Ltd, 2010 Anthon Pang
   * Licensed under BSD-3-Clause
   */
  /**
   * Dispatch function to all specified trackers from the supplied collection
   *
   * @param trackers - An optional list of trackers to send the event to, or will send to all trackers
   * @param trackerCollection - The collection which the trackers will be selected from
   * @param fn - The function which will run against each tracker
   */
  function dispatchToTrackersInCollection(trackers, trackerCollection, fn) {
      try {
          getTrackersFromCollection(trackers !== null && trackers !== void 0 ? trackers : Object.keys(trackerCollection), trackerCollection).forEach(fn);
      }
      catch (ex) {
          LOG.error('Function failed', ex);
      }
  }
  function getTrackersFromCollection(trackerIds, trackerCollection) {
      var trackers = [];
      for (var _i = 0, trackerIds_1 = trackerIds; _i < trackerIds_1.length; _i++) {
          var id = trackerIds_1[_i];
          if (trackerCollection.hasOwnProperty(id)) {
              trackers.push(trackerCollection[id]);
          }
          else {
              LOG.warn(id + ' not configured');
          }
      }
      return trackers;
  }

  var CART_SCHEMA = 'iglu:com.snowplowanalytics.snowplow.ecommerce/cart/jsonschema/1-0-0';
  var ECOMMERCE_ACTION_SCHEMA = 'iglu:com.snowplowanalytics.snowplow.ecommerce/snowplow_ecommerce_action/jsonschema/1-0-2';
  var CHECKOUT_STEP_SCHEMA = 'iglu:com.snowplowanalytics.snowplow.ecommerce/checkout_step/jsonschema/1-0-0';
  var PRODUCT_SCHEMA = 'iglu:com.snowplowanalytics.snowplow.ecommerce/product/jsonschema/1-0-0';
  var PAGE_SCHEMA = 'iglu:com.snowplowanalytics.snowplow.ecommerce/page/jsonschema/1-0-0';
  var USER_SCHEMA = 'iglu:com.snowplowanalytics.snowplow.ecommerce/user/jsonschema/1-0-0';
  var TRANSACTION_SCHEMA = 'iglu:com.snowplowanalytics.snowplow.ecommerce/transaction/jsonschema/1-0-0';
  var PROMO_SCHEMA = 'iglu:com.snowplowanalytics.snowplow.ecommerce/promotion/jsonschema/1-0-0';
  var REFUND_SCHEMA = 'iglu:com.snowplowanalytics.snowplow.ecommerce/refund/jsonschema/1-0-0';
  var TRANSACTION_ERROR_SCHEMA = 'iglu:com.snowplowanalytics.snowplow.ecommerce/transaction_error/jsonschema/1-0-0';

  /**
   * Build an Ecommerce Action Event
   * For tracking ecommerce actions
   *
   * @param event - Contains the properties for Cart related events
   * @returns PayloadBuilder to be sent to {@link @snowplow/tracker-core#TrackerCore.track}
   */
  function buildEcommerceActionEvent(event) {
      return buildSelfDescribingEvent({
          event: {
              schema: ECOMMERCE_ACTION_SCHEMA,
              data: removeEmptyProperties(__assign({}, event)),
          },
      });
  }
  /**
   * Returns a copy of a JSON with undefined and null properties removed
   *
   * @param event - Object to clean
   * @param exemptFields - Set of fields which should not be removed even if empty
   * @returns A cleaned copy of eventJson
   */
  function removeEmptyProperties(event) {
      var ret = {};
      for (var k in event) {
          if (event[k] !== null && typeof event[k] !== 'undefined') {
              ret[k] = event[k];
          }
      }
      return ret;
  }

  var _trackers = {};
  /* Scheduled to include Page and User */
  var _context = {};
  /**
   * Adds ecommerce tracking
   */
  function SnowplowEcommercePlugin() {
      var trackerId;
      return {
          activateBrowserPlugin: function (tracker) {
              trackerId = tracker.id;
              _trackers[trackerId] = tracker;
              _context[trackerId] = [];
          },
          contexts: function () {
              return _context[trackerId] || [];
          },
      };
  }
  /**
   * Track a checkout step
   *
   * @param checkoutStep - The checkout step index and the attributes the user filled in.
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function trackCheckoutStep(checkoutStep, trackers) {
      if (trackers === void 0) { trackers = Object.keys(_trackers); }
      var _a = checkoutStep.context, context = _a === void 0 ? [] : _a, timestamp = checkoutStep.timestamp, checkoutStepAttributes = __rest(checkoutStep, ["context", "timestamp"]);
      context.push({ schema: CHECKOUT_STEP_SCHEMA, data: __assign({}, checkoutStepAttributes) });
      dispatchToTrackersInCollection(trackers, _trackers, function (t) {
          t.core.track(buildEcommerceActionEvent({ type: 'checkout_step' }), context, timestamp);
      });
  }
  /**
   * Track a product list view
   *
   * @param listView - The list name along with the products which were viewed by the visitor.
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function trackProductListView(listView, trackers) {
      if (trackers === void 0) { trackers = Object.keys(_trackers); }
      var _a = listView.context, context = _a === void 0 ? [] : _a, timestamp = listView.timestamp, _b = listView.products, products = _b === void 0 ? [] : _b, name = listView.name;
      products.forEach(function (product) { return context.push({ schema: PRODUCT_SCHEMA, data: __assign({}, product) }); });
      dispatchToTrackersInCollection(trackers, _trackers, function (t) {
          t.core.track(buildEcommerceActionEvent({ type: 'list_view', name: name }), context, timestamp);
      });
  }
  /**
   * Track a product list click event
   *
   * @param listClick - The list name together with the information of the product which was clicked.
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function trackProductListClick(listClick, trackers) {
      if (trackers === void 0) { trackers = Object.keys(_trackers); }
      var _a = listClick.context, context = _a === void 0 ? [] : _a, timestamp = listClick.timestamp, name = listClick.name, product = listClick.product;
      context.push({ schema: PRODUCT_SCHEMA, data: product });
      dispatchToTrackersInCollection(trackers, _trackers, function (t) {
          t.core.track(buildEcommerceActionEvent({ type: 'list_click', name: name }), context, timestamp);
      });
  }
  /**
   * Track a promotion view
   *
   * @param promotionView - The promotion viewed by the visitor.
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function trackPromotionView(promotionView, trackers) {
      if (trackers === void 0) { trackers = Object.keys(_trackers); }
      var _a = promotionView.context, context = _a === void 0 ? [] : _a, timestamp = promotionView.timestamp, promotion = __rest(promotionView, ["context", "timestamp"]);
      context.push({ schema: PROMO_SCHEMA, data: __assign({}, promotion) });
      dispatchToTrackersInCollection(trackers, _trackers, function (t) {
          t.core.track(buildEcommerceActionEvent({ type: 'promo_view' }), context, timestamp);
      });
  }
  /**
   * Track a promotion click
   *
   * @param promotionClick - The promotion selected by the visitor.
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function trackPromotionClick(promotionClick, trackers) {
      if (trackers === void 0) { trackers = Object.keys(_trackers); }
      var _a = promotionClick.context, context = _a === void 0 ? [] : _a, timestamp = promotionClick.timestamp, promotion = __rest(promotionClick, ["context", "timestamp"]);
      context.push({ schema: PROMO_SCHEMA, data: __assign({}, promotion) });
      dispatchToTrackersInCollection(trackers, _trackers, function (t) {
          t.core.track(buildEcommerceActionEvent({ type: 'promo_click' }), context, timestamp);
      });
  }
  /**
   * Track a product view/detail
   *
   * @param productView - The product which was viewed in a product detail page.
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function trackProductView(productView, trackers) {
      if (trackers === void 0) { trackers = Object.keys(_trackers); }
      var _a = productView.context, context = _a === void 0 ? [] : _a, timestamp = productView.timestamp, product = __rest(productView, ["context", "timestamp"]);
      context.push({ schema: PRODUCT_SCHEMA, data: __assign({}, product) });
      dispatchToTrackersInCollection(trackers, _trackers, function (t) {
          t.core.track(buildEcommerceActionEvent({ type: 'product_view' }), context, timestamp);
      });
  }
  /**
   * Track a product addition to cart
   *
   * @param cart - The product/s which was/were added to the cart and the total value of the cart after the product was added.
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function trackAddToCart(cart, trackers) {
      if (trackers === void 0) { trackers = Object.keys(_trackers); }
      var _a = cart.context, context = _a === void 0 ? [] : _a, timestamp = cart.timestamp, _b = cart.products, products = _b === void 0 ? [] : _b, cartAttributes = __rest(cart, ["context", "timestamp", "products"]);
      products.forEach(function (product) { return context.push({ schema: PRODUCT_SCHEMA, data: __assign({}, product) }); });
      context.push({ schema: CART_SCHEMA, data: __assign({}, cartAttributes) });
      dispatchToTrackersInCollection(trackers, _trackers, function (t) {
          t.core.track(buildEcommerceActionEvent({ type: 'add_to_cart' }), context, timestamp);
      });
  }
  /**
   * Track removal of products from cart
   *
   * @param cart - The product/s which were removed from the cart and the total value of the cart after the product was removed.
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function trackRemoveFromCart(cart, trackers) {
      if (trackers === void 0) { trackers = Object.keys(_trackers); }
      var _a = cart.context, context = _a === void 0 ? [] : _a, timestamp = cart.timestamp, _b = cart.products, products = _b === void 0 ? [] : _b, cartAttributes = __rest(cart, ["context", "timestamp", "products"]);
      products.forEach(function (product) { return context.push({ schema: PRODUCT_SCHEMA, data: __assign({}, product) }); });
      context.push({ schema: CART_SCHEMA, data: __assign({}, cartAttributes) });
      dispatchToTrackersInCollection(trackers, _trackers, function (t) {
          t.core.track(buildEcommerceActionEvent({ type: 'remove_from_cart' }), context, timestamp);
      });
  }
  /**
   * Track a transaction event
   *
   * @param transaction - The transaction information
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function trackTransaction(transaction, trackers) {
      if (trackers === void 0) { trackers = Object.keys(_trackers); }
      var totalQuantity = 0;
      var _a = transaction.context, context = _a === void 0 ? [] : _a, timestamp = transaction.timestamp, _b = transaction.products, products = _b === void 0 ? [] : _b, transactionAttributes = __rest(transaction, ["context", "timestamp", "products"]);
      products.forEach(function (product) {
          /* If `total_quantity` is not provided, we calculate it from individual product quantities. */
          if (product.quantity) {
              totalQuantity += product.quantity;
          }
          context.push({ schema: PRODUCT_SCHEMA, data: product });
      });
      context.push({
          schema: TRANSACTION_SCHEMA,
          data: __assign({ total_quantity: totalQuantity || undefined }, transactionAttributes),
      });
      dispatchToTrackersInCollection(trackers, _trackers, function (t) {
          t.core.track(buildEcommerceActionEvent({ type: 'transaction' }), context, timestamp);
      });
  }
  /**
   * Track a refund event
   *
   * @param refund - The refund information
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function trackRefund(refund, trackers) {
      if (trackers === void 0) { trackers = Object.keys(_trackers); }
      var _a = refund.context, context = _a === void 0 ? [] : _a, timestamp = refund.timestamp, _b = refund.products, products = _b === void 0 ? [] : _b, refundAttributes = __rest(refund, ["context", "timestamp", "products"]);
      products.forEach(function (product) { return context.push({ schema: PRODUCT_SCHEMA, data: product }); });
      context.push({ schema: REFUND_SCHEMA, data: __assign({}, refundAttributes) });
      dispatchToTrackersInCollection(trackers, _trackers, function (t) {
          t.core.track(buildEcommerceActionEvent({ type: 'refund' }), context, timestamp);
      });
  }
  /**
   * Track a transaction error event
   *
   * @param transactionError - The transaction error information
   * @param trackers - The tracker identifiers which the event will be sent to
   */
  function trackTransactionError(transactionError, trackers) {
      if (trackers === void 0) { trackers = Object.keys(_trackers); }
      var _a = transactionError.context, context = _a === void 0 ? [] : _a, timestamp = transactionError.timestamp, transaction = transactionError.transaction, transactionErrorAttributes = __rest(transactionError, ["context", "timestamp", "transaction"]);
      context.push({
          schema: TRANSACTION_SCHEMA,
          data: __assign({}, transaction),
      });
      context.push({ schema: TRANSACTION_ERROR_SCHEMA, data: __assign({}, transactionErrorAttributes) });
      dispatchToTrackersInCollection(trackers, _trackers, function (t) {
          t.core.track(buildEcommerceActionEvent({ type: 'trns_error' }), context, timestamp);
      });
  }
  /**
   * Set Ecommerce Page context
   *
   * @param context - The ecommerce page context to be stored
   * @param trackers - The tracker identifiers which the context will be stored
   */
  function setPageType(context, trackers) {
      if (trackers === void 0) { trackers = Object.keys(_trackers); }
      var type = context.type, language = context.language, locale = context.locale;
      trackers.forEach(function (trackerId) {
          if (_context[trackerId]) {
              _context[trackerId] = removeContext(_context[trackerId], PAGE_SCHEMA);
              _context[trackerId].push({
                  schema: PAGE_SCHEMA,
                  data: {
                      type: type,
                      language: language,
                      locale: locale,
                  },
              });
          }
      });
  }
  /**
   * Set Ecommerce User context
   *
   * @param context - The ecommerce user context to be stored
   * @param trackers - The tracker identifiers which the context will be stored
   */
  function setEcommerceUser(context, trackers) {
      if (trackers === void 0) { trackers = Object.keys(_trackers); }
      var id = context.id, is_guest = context.is_guest, email = context.email;
      trackers.forEach(function (trackerId) {
          if (_context[trackerId]) {
              _context[trackerId] = removeContext(_context[trackerId], USER_SCHEMA);
              _context[trackerId].push({
                  schema: USER_SCHEMA,
                  data: {
                      id: id,
                      is_guest: is_guest,
                      email: email,
                  },
              });
          }
      });
  }
  /**
   * Return a new array with the context matching the `schemaToRemove` removed from the array.
   * Used in cases where we want only one type of the said context on the context array for a tracker.
   */
  function removeContext(trackerContext, schemaToRemove) {
      return trackerContext.filter(function (context) { return context.schema !== schemaToRemove; });
  }

  function transformUAProductsToSPProducts(products, currency) {
      return products.map(function (product) {
          return {
              currency: currency,
              /* Id or name is required, but we in SP-plugin we require id to be present */
              id: product.id || product.name,
              price: Number(product.price),
              name: product.name,
              position: product.position,
              brand: product.brand,
              category: product.category,
              variant: product.variant,
              quantity: product.quantity,
          };
      });
  }
  function transformUAPromotionsToSPPromotions(promotions) {
      return promotions.map(function (promotion) { return ({
          name: promotion.name,
          slot: promotion.position,
          /* Id or name is required, but we in SP-plugin we require id to be present */
          id: promotion.id || promotion.name,
          creative_id: promotion.creative,
      }); });
  }

  var DEFAULT_PAYMENT_METHOD$1 = 'unknown';
  function trackEnhancedEcommercePromoView(ecommerce) {
      var promotions = transformUAPromotionsToSPPromotions(ecommerce.promoView.promotions);
      /* Enhanced Ecommerce allows multiple promotions to be sent on a single event. */
      for (var i = 0; i < promotions.length; i++) {
          trackPromotionView(promotions[i]);
      }
  }
  function trackEnhancedEcommercePromoClick(ecommerce) {
      var promotion = transformUAPromotionsToSPPromotions(ecommerce.promoClick.promotions)[0];
      trackPromotionClick(promotion);
  }
  function trackEnhancedEcommerceAddToCart(ecommerce, opts) {
      var currency = (ecommerce.currencyCode || opts.currency);
      var products = transformUAProductsToSPProducts(ecommerce.add.products, currency);
      trackAddToCart({ products: products, total_value: opts.finalCartValue, currency: currency });
  }
  function trackEnhancedEcommerceRemoveFromCart(ecommerce, opts) {
      var currency = (ecommerce.currencyCode || opts.currency);
      var products = transformUAProductsToSPProducts(ecommerce.remove.products, currency);
      trackRemoveFromCart({ products: products, total_value: opts.finalCartValue, currency: currency });
  }
  function trackEnhancedEcommerceProductDetail(ecommerce, opts) {
      if (opts === void 0) { opts = {}; }
      var currency = (ecommerce.currencyCode || opts.currency);
      var products = transformUAProductsToSPProducts(ecommerce.detail.products, currency);
      trackProductView(__assign({}, products[0]));
  }
  function trackEnhancedEcommerceProductListView(ecommerce, opts) {
      if (opts === void 0) { opts = {}; }
      var currency = (ecommerce.currencyCode || opts.currency);
      var products = transformUAProductsToSPProducts(ecommerce.impressions, currency);
      trackProductListView({ name: ecommerce.impressions[0].list, products: products });
  }
  function trackEnhancedEcommerceProductListClick(ecommerce, opts) {
      if (opts === void 0) { opts = {}; }
      var currency = (ecommerce.currencyCode || opts.currency);
      var product = transformUAProductsToSPProducts(ecommerce.click.products, currency)[0];
      trackProductListClick({ name: ecommerce.click.actionField.list, product: product });
  }
  function trackEnhancedEcommerceCheckoutStep(ecommerce, checkoutOption) {
      trackCheckoutStep(__assign({ step: ecommerce.checkout.actionField.step }, checkoutOption));
  }
  function trackEnhancedEcommercePurchase(ecommerce, opts) {
      var currency = (ecommerce.currencyCode || opts.currency);
      var products = transformUAProductsToSPProducts(ecommerce.purchase.products, currency);
      trackTransaction({
          products: products,
          transaction_id: ecommerce.purchase.actionField.id,
          currency: currency,
          revenue: Number(ecommerce.purchase.actionField.revenue),
          payment_method: opts.paymentMethod || DEFAULT_PAYMENT_METHOD$1,
          tax: Number(ecommerce.purchase.actionField.tax) || undefined,
          shipping: Number(ecommerce.purchase.actionField.shipping) || undefined,
      });
  }

  function transformG4ItemsToSPProducts(_a, currency) {
      var items = _a.items, _b = _a.categorySeparator, categorySeparator = _b === void 0 ? '/' : _b;
      return items.map(function (ga4Item) {
          var item_category = ga4Item.item_category, item_category2 = ga4Item.item_category2, item_category3 = ga4Item.item_category3, item_category4 = ga4Item.item_category4, item_category5 = ga4Item.item_category5;
          var category = [item_category, item_category2, item_category3, item_category4, item_category5]
              .filter(Boolean)
              .join(categorySeparator);
          return {
              currency: currency,
              id: ga4Item.item_id,
              name: ga4Item.item_name,
              list_price: ga4Item.price,
              price: roundToTwo(ga4Item.price - (ga4Item.discount || 0)),
              position: ga4Item.index,
              brand: ga4Item.item_brand,
              category: category,
              variant: ga4Item.item_variant,
              quantity: ga4Item.quantity,
          };
      });
  }
  function transformGA4PromotionToSPPromotion(promotion) {
      var productIds = promotion.items.map(function (item) { return item.item_id; });
      return {
          id: promotion.promotion_id,
          name: promotion.promotion_name,
          creative_id: promotion.creative_name,
          slot: promotion.creative_slot,
          product_ids: productIds,
      };
  }
  function roundToTwo(num) {
      // @ts-ignore
      return +(Math.round(num + 'e+2') + 'e-2');
  }

  var DEFAULT_PAYMENT_METHOD = 'unknown';
  function trackGA4ViewCart() {
      console.log('This function could be similarly tracked with the `setPageType` or `trackCheckoutStep` API.');
  }
  function trackGA4ViewPromotion(ecommerce) {
      var promotion = transformGA4PromotionToSPPromotion(ecommerce);
      trackPromotionView(promotion);
  }
  function trackGA4SelectPromotion(ecommerce) {
      var promotion = transformGA4PromotionToSPPromotion(ecommerce);
      trackPromotionClick(promotion);
  }
  function trackGA4AddToCart(ecommerce, opts) {
      var currency = (ecommerce.currency || opts.currency);
      var products = transformG4ItemsToSPProducts(ecommerce, currency);
      trackAddToCart({ products: products, total_value: opts.finalCartValue, currency: currency });
  }
  function trackGA4RemoveFromCart(ecommerce, opts) {
      var currency = (ecommerce.currency || opts.currency);
      var products = transformG4ItemsToSPProducts(ecommerce, currency);
      trackRemoveFromCart({ products: products, total_value: opts.finalCartValue, currency: currency });
  }
  function trackGA4ViewItem(ecommerce, opts) {
      if (opts === void 0) { opts = {}; }
      var currency = (ecommerce.currency || opts.currency);
      var products = transformG4ItemsToSPProducts(ecommerce, currency);
      trackProductView(__assign({}, products[0]));
  }
  function trackGA4ViewItemList(ecommerce, opts) {
      if (opts === void 0) { opts = {}; }
      var currency = (ecommerce.currency || opts.currency);
      var products = transformG4ItemsToSPProducts(ecommerce, currency);
      trackProductListView({ name: ecommerce.item_list_id || ecommerce.item_list_name, products: products });
  }
  function trackGA4SelectItem(ecommerce, opts) {
      if (opts === void 0) { opts = {}; }
      var currency = (ecommerce.currency || opts.currency);
      var product = transformG4ItemsToSPProducts(ecommerce, currency)[0];
      trackProductListClick({ name: ecommerce.item_list_id || ecommerce.item_list_name, product: product });
  }
  function trackGA4BeginCheckout(opts) {
      if (opts === void 0) { opts = {}; }
      trackCheckoutStep({ step: opts.step || 1 });
  }
  function trackGA4AddShippingInfo(ecommerce, opts) {
      trackCheckoutStep({ step: opts.step, delivery_method: ecommerce.shipping_tier });
  }
  function trackGA4AddPaymentOptions(ecommerce, opts) {
      trackCheckoutStep({ step: opts.step, payment_method: ecommerce.payment_type });
  }
  function trackGA4Transaction(ecommerce, opts) {
      var currency = (ecommerce.currency || opts.currency);
      var products = transformG4ItemsToSPProducts(ecommerce, currency);
      trackTransaction({
          products: products,
          transaction_id: ecommerce.transaction_id,
          currency: currency,
          revenue: ecommerce.value,
          payment_method: opts.paymentMethod || DEFAULT_PAYMENT_METHOD,
          tax: ecommerce.tax,
          shipping: ecommerce.shipping,
      });
  }

  exports.SnowplowEcommercePlugin = SnowplowEcommercePlugin;
  exports.setEcommerceUser = setEcommerceUser;
  exports.setPageType = setPageType;
  exports.trackAddToCart = trackAddToCart;
  exports.trackCheckoutStep = trackCheckoutStep;
  exports.trackEnhancedEcommerceAddToCart = trackEnhancedEcommerceAddToCart;
  exports.trackEnhancedEcommerceCheckoutStep = trackEnhancedEcommerceCheckoutStep;
  exports.trackEnhancedEcommerceProductDetail = trackEnhancedEcommerceProductDetail;
  exports.trackEnhancedEcommerceProductListClick = trackEnhancedEcommerceProductListClick;
  exports.trackEnhancedEcommerceProductListView = trackEnhancedEcommerceProductListView;
  exports.trackEnhancedEcommercePromoClick = trackEnhancedEcommercePromoClick;
  exports.trackEnhancedEcommercePromoView = trackEnhancedEcommercePromoView;
  exports.trackEnhancedEcommercePurchase = trackEnhancedEcommercePurchase;
  exports.trackEnhancedEcommerceRemoveFromCart = trackEnhancedEcommerceRemoveFromCart;
  exports.trackGA4AddPaymentOptions = trackGA4AddPaymentOptions;
  exports.trackGA4AddShippingInfo = trackGA4AddShippingInfo;
  exports.trackGA4AddToCart = trackGA4AddToCart;
  exports.trackGA4BeginCheckout = trackGA4BeginCheckout;
  exports.trackGA4RemoveFromCart = trackGA4RemoveFromCart;
  exports.trackGA4SelectItem = trackGA4SelectItem;
  exports.trackGA4SelectPromotion = trackGA4SelectPromotion;
  exports.trackGA4Transaction = trackGA4Transaction;
  exports.trackGA4ViewCart = trackGA4ViewCart;
  exports.trackGA4ViewItem = trackGA4ViewItem;
  exports.trackGA4ViewItemList = trackGA4ViewItemList;
  exports.trackGA4ViewPromotion = trackGA4ViewPromotion;
  exports.trackProductListClick = trackProductListClick;
  exports.trackProductListView = trackProductListView;
  exports.trackProductView = trackProductView;
  exports.trackPromotionClick = trackPromotionClick;
  exports.trackPromotionView = trackPromotionView;
  exports.trackRefund = trackRefund;
  exports.trackRemoveFromCart = trackRemoveFromCart;
  exports.trackTransaction = trackTransaction;
  exports.trackTransactionError = trackTransactionError;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=index.umd.js.map
